<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="filters-top">
        <div class="row align-items-center d-flex">
            <div class="col-xl-5">
                <div class="filters-top-left">
                    <slot></slot>
                </div>
            </div>
            <div class="col-xl-7">
                <div class="filters-top-right">
                    <form class="search-wrapper">
                        <i class="icon-search"></i>
                        <label for="search" class="d-none">search</label>
                        <input type="text" placeholder="Search" class="input-search" v-model="searchQuery" name="search" aria-label="Search">
                    </form>
                    <div class="filter-top-filter-area">
                        <button :class="['filters-top-button', filterOpen ? 'active' : '']" id="filters-top-button"
                            @click="filterOpen = !filterOpen"><i class="icon-filters icon-filter"></i>Filters</button>
                    </div>
                    <Fragment v-if="sortOptions">
                        <Select :options="sortOptions" ref="sortOptionSelected" @change="handleSort" />
                    </Fragment>
                </div>
            </div>
        </div>
        <div v-if="filterOpen" class="filters-wrapper">
            <FiltersArea :filterOpen="filterOpen" @toggleFilter="toggleFilterOpen" @applyFilters="handleApplyFilters"
                :data="data" />
        </div>
    </div>
</template>
<script setup lang="ts">

import type DataTableI from '~/interfaces/datatable';
import FiltersArea from './filters/FiltersArea.vue';
import { ref } from 'vue';

const props = defineProps<{ data?: DataTableI }>()

const data = props.data ?? {} as DataTableI;

const searchQuery = ref<string>('');

const filters = ref({
    name: '',
    description: '',
    shortDescription: ''
});

const filterOpen = ref(false);

// Reactive property to store the selected sort configuration (column and order)
const sortConfig = ref<{ column: string, order: 'asc' | 'desc' }>({
    column: 'updated_at',
    order: 'desc'
});

const sortOptions = ref([
    {
        name: 'Last updated',
        column: 'updated_at',
        order: 'desc'
    },
    {
        name: 'Recent first',
        column: 'created_at',
        order: 'asc'
    },
    {
        name: 'Older first',
        column: 'created_at',
        order: 'desc'
    },
]);

const sortOptionSelected = ref(null);

// Handle sort change event
const handleSort = (selectedOption: any) => {
    if (selectedOption && selectedOption.column && selectedOption.order) {
        sortConfig.value.column = selectedOption.column;
        sortConfig.value.order = selectedOption.order;
    }
};

// Handle filter application// Function to handle the event when filters are applied
const handleApplyFilters = (newFilters: { name: string, description: string, shortDescription: string }) => {
    // Update filters
    filters.value = newFilters;
};

// Function to toggle the filterOpen state
const toggleFilterOpen = () => {
    filterOpen.value = !filterOpen.value;
};


</script>